import { jsx as u } from "react/jsx-runtime";
import { lazy as p } from "react";
const m = (g, t) => {
  const e = g[t];
  return e ? typeof e == "function" ? e() : Promise.resolve(e) : new Promise((s, n) => {
    (typeof queueMicrotask == "function" ? queueMicrotask : setTimeout)(n.bind(null, new Error("Unknown variable dynamic import: " + t)));
  });
};
class c {
  static populatePagesInRoutes(t) {
    t && t.forEach((e) => {
      if (typeof e.element == "string") {
        const s = e.element, n = p(
          () => m(/* @__PURE__ */ Object.assign({}), `../pages/${s}/${s}.tsx`).catch(
            () => import("../Component_404.js")
          )
        );
        e.element = /* @__PURE__ */ u(n, {}), e.children && c.populateComponentsInRoutes(e.children);
      }
    });
  }
  static populateComponentsInRoutes(t) {
    t && t.forEach((e) => {
      const s = e.hierarchy;
      if (typeof e.element == "string") {
        const n = e.element, i = p(
          () => m(/* @__PURE__ */ Object.assign({}), `../components/${s}/${n}/${n}.tsx`).catch(() => import("../Component_404.js"))
        );
        e.element = /* @__PURE__ */ u(i, {}), e.children && c.populateComponentsInRoutes(e.children);
      }
    });
  }
  static recrusiveFilter(t, e, s, n) {
    return !e || !t || t.length === 0 ? t : ((!n || n.length === 0) && (n = ["label", "name", "id", "value"]), JSON.parse(JSON.stringify(t)).filter((o) => n && n.reduce((r, l) => {
      let d = o[l] && (s ? o[l].indexOf(e) > -1 : o[l] && o[l].toString().toLowerCase().indexOf(e.toLowerCase()) > -1);
      return o.children && (o.children = c.recrusiveFilter(
        o.children,
        e,
        s
      ), d = d || o.children.length > 0), r || d;
    }, !1)));
  }
  static generateSlices(t, e, s) {
    let n = 0, i = 0;
    const a = [];
    for (; n < t; ) {
      let o = e;
      n + e > t && (o = t % e);
      const r = s === "range" ? n + 1 + " - " + (n + o) : "" + (i + 1);
      a.push({
        label: r,
        name: r.replace(/ /g, "").replace(/-/g, "to"),
        sliceIndex: i,
        startIndex: n,
        endIndex: n + o - 1
      }), n += e, i++;
    }
    return a;
  }
  static aggregate(t, e) {
    let s = {};
    return t.forEach((n) => {
      const i = n[e];
      let a = s[i];
      a || (a = [], s[i] = a), a.push(n);
    }), s;
  }
  static generateCategories(t, e) {
    const s = {};
    return e && t && e.forEach((n) => {
      let i = c.aggregate(
        t,
        n
      );
      s[n] = i;
    }), s;
  }
  static toCamelCase(t, e, s) {
    return t.split(e || " ").map(
      (i, a) => a === 0 && s ? i.charAt(0).toUpperCase() + i.slice(1) : i
    ).join("");
  }
  static generateRandomId(t = 8) {
    return Math.random().toString(36).substring(2, t + 2);
  }
  static copyOrPrompt(t, e) {
    c.copyToClipboard(t) ? e && e() : prompt("Clipboard (Select: ⌘+a > Copy: ⌘+c)", t);
  }
  static copyToClipboard(t) {
    return typeof window.safari > "u" ? (t && navigator.clipboard.writeText(t), !0) : !1;
  }
  static findComponentDescription(t, e) {
    let s, n = e.ATOMS.components.find(
      (i) => (typeof i == "string" ? i : i.name) === t
    );
    return n ? s = "ATOMS" : (n = e.MOLECULES.components.find(
      (i) => (typeof i == "string" ? i : i.name) === t
    ), n && (s = "MOLECULES")), {
      selectedItem: JSON.parse(JSON.stringify(n)),
      hierarchy: s,
      component: t
    };
  }
  static matchArrayFilters(t, e, s, n) {
    return e && t ? n && n === "starts" ? t.filter(
      (i) => e.findIndex(
        (a) => i[s].toLowerCase().startsWith(a.toLowerCase())
      ) > -1
    ) : t.filter(
      (i) => e.findIndex(
        (a) => i[s].toLowerCase() === a.value.toLowerCase()
      ) > -1
    ) : t;
  }
  static importComponent(t, e) {
    return p(
      () => m(/* @__PURE__ */ Object.assign({}), `../components/${e}/${t}/${t}.tsx`).catch(
        () => import("../Component_404.js")
      )
    );
  }
  //// Style related helpers
  static injectGlobalInFrame(t) {
    const e = (s) => ({
      clipStart: s && s.indexOf("html {\\n  font-size: 16px")
    });
    c.injectScssInFrame(
      "/src/app/static/styles/_global.scss",
      t,
      void 0,
      e
    );
  }
  static injectBootstrapInFrame(t) {
    c.injectLinkInFrame("/src/app/static/styles/bootstrap.min.css", t);
  }
  static injectVariablesInFrame(t) {
    c.injectScssInFrame("/src/app/static/styles/_variables.scss", t);
  }
  static injectEditorStyleInFrame(t) {
    c.injectScssInFrame(
      "/src/app/components/Editor/Editor.component.scss",
      t
    );
  }
  static injectComponentStyleInFrame(t, e, s) {
    var n;
    if (e && t && t.name) {
      const i = (n = s == null ? void 0 : s.contentWindow) == null ? void 0 : n.document.querySelector("style.component-style");
      i && i.remove(), (t.uses ? [
        { name: t.name, hierarchy: e },
        ...t.uses
      ] : [{ name: t.name, hierarchy: e }]).forEach(
        (o) => {
          const r = `/src/app/components/${o.hierarchy.toLowerCase()}/${o.name}/${o.name}.component.scss`;
          c.injectScssInFrame(r, s, o);
        }
      );
    }
  }
  static injectScssInFrame(t, e, s, n) {
    import("../sass.default-33fb3cd6.js").then((i) => {
      const { compileString: a } = i;
      fetch(t).then((o) => o.text()).then((o) => {
        const { clipStart: r, clipEnd: l } = n ? n(o) : () => ({});
        o = o.substring(
          r || o.indexOf("__vite__css = ") + 15,
          l || o.indexOf("__vite__updateStyle(") - 2
        ).replace(/\\n/g, "").replace(/\\"/g, '"');
        const d = a(o).css;
        c.injectStyleInFrame(d, e, s);
      });
    });
  }
  static injectStyleInFrame(t, e, s) {
    var i, a;
    const n = document.createElement("style");
    s && s.name && (n.setAttribute("id", s.name), n.setAttribute("class", "component-style")), n.appendChild(document.createTextNode(t)), (a = (i = e == null ? void 0 : e.contentWindow) == null ? void 0 : i.document) == null || a.head.appendChild(n);
  }
  static injectLinkInFrame(t, e) {
    var s, n;
    if (Array.isArray(t)) {
      const i = document.querySelectorAll("link[rel='stylesheet']");
      t.forEach((a) => {
        Array.from(i).forEach((o) => {
          var l, d;
          const r = o.getAttribute("href");
          if (r && r.startsWith(`/assets/${a}`)) {
            const f = o.cloneNode(!0);
            (d = (l = e == null ? void 0 : e.contentWindow) == null ? void 0 : l.document) == null || d.head.appendChild(f);
          }
        });
      });
    } else {
      const i = document.createElement("link");
      i.href = t, i.rel = "stylesheet", i.type = "text/css", (n = (s = e == null ? void 0 : e.contentWindow) == null ? void 0 : s.document) == null || n.head.appendChild(i);
    }
  }
  static getStylesFromClass(t) {
    const e = Array.from(document.styleSheets).find(
      (s) => Array.from(s.cssRules).some(
        (n) => n instanceof CSSStyleRule && n.selectorText === `.${t}`
      )
    );
    if (e) {
      const s = Array.from(e.cssRules).find(
        (n) => n instanceof CSSStyleRule && n.selectorText === `.${t}`
      );
      if (s) {
        const n = {};
        for (let i = 0; i < s.style.length; i++) {
          const a = s.style[i];
          n[a] = s.style.getPropertyValue(a);
        }
        return n;
      }
    }
    return {};
  }
  static debounce(t, e, s = !1) {
    let n;
    return function(...i) {
      const a = () => {
        n = void 0, s || t(...i);
      };
      clearTimeout(n), s && !n && t(...i), n = setTimeout(a, e || 1e3);
    };
  }
  static isMobile() {
    let t = !1;
    return function(e) {
      (/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino|android|ipad|playbook|silk/i.test(
        e
      ) || /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw-(n|u)|c55\/|capi|ccwa|cdm-|cell|chtm|cldc|cmd-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc-s|devi|dica|dmob|do(c|p)o|ds(12|-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(-|_)|g1 u|g560|gene|gf-5|g-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd-(m|p|t)|hei-|hi(pt|ta)|hp( i|ip)|hs-c|ht(c(-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i-(20|go|ma)|i230|iac( |-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|-[a-w])|libw|lynx|m1-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|-([1-8]|c))|phil|pire|pl(ay|uc)|pn-2|po(ck|rt|se)|prox|psio|pt-g|qa-a|qc(07|12|21|32|60|-[2-7]|i-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h-|oo|p-)|sdk\/|se(c(-|0|1)|47|mc|nd|ri)|sgh-|shar|sie(-|m)|sk-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h-|v-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl-|tdg-|tel(i|m)|tim-|t-mo|to(pl|sh)|ts(70|m-|m3|m5)|tx-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas-|your|zeto|zte-/i.test(
        e.substr(0, 4)
      )) && (t = !0);
    }(
      navigator.userAgent || navigator.vendor || "opera" in window && window.opera
    ), t;
  }
  static download(t, e) {
    const s = document.createElement("a");
    s.href = window.URL.createObjectURL(t), s.download = e, document.body.appendChild(s), s.click(), document.body.removeChild(s);
  }
}
export {
  c as default
};
